package dao.impl;

import java.util.List;

import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.queryParser.MultiFieldQueryParser;
import org.apache.lucene.queryParser.ParseException;
import org.hibernate.Criteria;
import org.hibernate.Transaction;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Restrictions;
import org.hibernate.search.FullTextSession;
import org.hibernate.search.Search;
import org.hibernatespatial.Circle;
import org.hibernatespatial.criterion.SpatialRestrictions;

import util.HibernateUtil;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.operation.buffer.BufferBuilder;

import model.Citynode;
import model.Context;

public class CitynodeDAOimpl extends GenericDAOimpl<Citynode,Long> implements dao.CitynodeDAO {

	private String[] fields = new String[]{"title"};
	
	
	public List<Citynode> findCityNodeWithin(Point p, double radius) 
	{
		return findByCriteria(SpatialRestrictions.within("location",p.buffer(0.005,4))); 
	}

	public Citynode findByID(Long id, boolean lock) {
		return super.findById(id, lock); 
	}

	@Override
	public List<Citynode> contains(Point userPosition) {
		
      //  testCriteria.add(SpatialRestrictions.contains("coveringArea",userPosition));
        
        List results = findByCriteria(SpatialRestrictions.contains("coveringArea",userPosition));//testCriteria.list();
        
        if(results==null || results.size()==0)
        	return null; 
        else  
        	return results;
		
	}

	@Override
	public List <Citynode> findBySearch(String searchString, Context context)  
	{
		
		   Transaction tx = this.getFullTextSession().beginTransaction();
	
		MultiFieldQueryParser parser = new MultiFieldQueryParser(fields, new StandardAnalyzer());
		org.apache.lucene.search.Query query;
		query = null;  
		try {
			query = parser.parse( searchString );
		} 
		catch (ParseException e) 
		{
			e.printStackTrace();
		}
		
		org.hibernate.Query hibQuery = getFullTextSession().createFullTextQuery(query, Citynode.class);

		List <Citynode> result = hibQuery.list();
		System.out.println("antall shit som ble funnet:" + result.size());  
		
		for(Citynode n : result)
		 { 
			 System.out.println(n.getTitle());
		 }
		   
		//   session.close();  
		
		tx.commit();
		return result;
	}

	@Override
	public List<Citynode> findCitynodeExperience(Context c) 
	{
		
		if(c.getIntrestField()==null)
			return findByCriteria(Restrictions.eq("category", "Activity")); 
		else
			return findByCriteria(Restrictions.eq("category", "Activity"),SpatialRestrictions.within("location",c.getIntrestField())); 
	}

	@Override
	public List<Citynode> findCitynodesEat(Context c) 
	{
		if(c.getIntrestField()==null)
			return findByCriteria(Restrictions.eq("category", "Restaurant")); 
		else
			return findByCriteria(Restrictions.eq("category", "Restaurant"),SpatialRestrictions.within("location",c.getIntrestField())); 
	}

	@Override
	public List<Citynode> findCitynodesSleep(Context c) 
	{
		if(c.getIntrestField()==null)
			return findByCriteria(Restrictions.eq("category", "Hotel")); 
		else
			return findByCriteria(Restrictions.eq("category", "Hotel"),SpatialRestrictions.within("location",c.getIntrestField())); 
	}


	




}
