package recommendersystem.impl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.hibernate.dialect.SAPDBDialect;
import org.w3c.dom.Node;

import model.Citynode;
import model.Context;
import model.Rating;
import model.Recommendation;
import model.User;
import model.UserModel;

import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.operation.distance.DistanceOp;

import dao.CitynodeDAO;
import dao.RatingDAO;
import dao.RecommendationDAO;
import dao.UserDAO;
import dao.UserModelDAO;
import dao.VisitDAO;

import recommendersystem.AbstractRecommenderSystem;
import recommendersystem.RecommenderSystem;

public class CollaborativeRecommenderSystem extends AbstractRecommenderSystem {

	

	private boolean isBinaryFeedback = true; 
	
	private double correlationTreshhold = 0.5; 
	
	
	private HashMap <String,String> explantionTemp = new HashMap<String,String>(); 
	
	private HashMap <String,Double> diffMap =  new HashMap<String,Double>(); 
	
	public CollaborativeRecommenderSystem  (CitynodeDAO cdao,RecommendationDAO rdao,UserDAO udao,UserModelDAO umdao,VisitDAO vdao,RatingDAO ratingdao)
	{ 
		super(cdao,rdao,udao,umdao,vdao,ratingdao); 
		
	}
	

		
		
		//private HashMap <Citynode,List<User>> buildUserRatingMap(List <Citynode> nodes,User u)
		
		protected List<Recommendation> buildRecommendationList(List <Citynode> nodes,User u,Context c)
		{
			
			HashMap <Citynode,List<User>> userRatings = getNodeUserMap(nodes,u); 

			
			List <Recommendation> returnRecommendation = new ArrayList<Recommendation>();
			
			System.out.println("kommer inn her");
			
			
			for(Citynode n:userRatings.keySet())
			{ 
			
					Recommendation newRec = new Recommendation();
					
					newRec.setNode(n); 
					
					double rating = 0; 
					int numberOfraters = 0; 
					
					List <Rating> selected = null;
					
					for(User user :userRatings.get(n))
					{
						Rating r =  user.getRating(n);
						
						if(r!=null)
						{
							r.setUserId(user.getId());
							if(	newRec.getSelectedRatings()!=null)
								newRec.getSelectedRatings().add(r); 
							else 
							{
								ArrayList <Rating> rs = new ArrayList<Rating>(); 
								rs.add(r); 
								newRec.setSelectedRatings(rs);
							}
							rating+=r.getRating(); 
							numberOfraters++; 
							if(user.getRating(n).getRating()>0.7 && selected==null)
							{
								selected = this.getRatingsInArea(user.getRatings(),n, c); 
							}
						}
					}
					
				
				
					
					newRec.setTextualExplanation("Recommended to you because of high average rating from "+ numberOfraters +" users that have rated places like " + this.explantionTemp.get(n.getCategory()) +" similarly as you"); 
					newRec.setSelectedRatings(selected);
					newRec.setSystemRating((int)((rating/numberOfraters)*100)); 
					
					if(rating>0.7)
					{
						returnRecommendation.add(newRec);
					}
				//	else 
				//	{
				//	}
				}
			
			
			Collections.sort(returnRecommendation); 
			
			List <Recommendation> retur = new ArrayList<Recommendation>(); 
			
			
			int numberToReturn = returnRecommendation.size()>3?3:returnRecommendation.size();
			
			for(int i=0;i<numberToReturn;i++)
			{
				retur.add(returnRecommendation.get(returnRecommendation.size()-1-i)); 
			}
			
			return retur;
			
			
		//	return userRatings; 
		}
		
		
		private HashMap <Citynode,List<User>>  getNodeUserMap(List<Citynode> nodes,User u)
		{
		
			HashMap <Citynode,List<User>> userRatings = new  HashMap <Citynode,List<User>>();
			
			for(Citynode node : nodes)
			{
				Set <User> raters = node.getRaters(); 
				for(User rater : raters)
				{
					double correlation = computeSim(rater,u); 
					if(true)
					{
						if((rater.getId()!=u.getId()))
						{
							if(userRatings.get(node)!=null)
							{
								userRatings.get(node).add(rater);  
							}
							else 
							{
								ArrayList<User> list = new ArrayList<User>(); 
								list.add(rater); 
								userRatings.put(node, list); 
							}
							
						}
					}	
				}
			
			}
			
			return userRatings;
		}

		
		private double computeMean(Set <Rating> ratins)
		{
			double mean = 0; 
			
			for(Rating rating:ratins)
			{
				mean+=rating.getRating();  
			}
			
			return mean/ratins.size(); 
		}
		
		
		
		private double computeSim(User a,User b)
		{
			Set <Rating> setU = a.getRatings().size()>b.getRatings().size()?a.getRatings():b.getRatings();
			Set <Rating> setV = setU.equals(a.getRatings())?b.getRatings():a.getRatings(); 
			
			
			HashMap<Double,String> explantion = new HashMap<Double,String>(); 
			
			
			double differnce = 0.0;
			double minDiff = 100000000; 
			
			int numberOfSimilar = 0; 
			
			for(Rating Ri : setU)
			{
				for(Rating Rj : setV)
				{
					if(Rj.getCitynode().getId()==Ri.getCitynode().getId())
					{
						differnce=+Math.abs(((Ri.getRating()-Rj.getRating())));
						explantion.put(Math.abs(Ri.getRating()-Rj.getRating()), Rj.getCitynode().getTitle()); 
						
						
						double max = Ri.getRating()+Rj.getRating(); 
						
						System.out.println("hva er dette:" + this.explantionTemp.get(Rj.getCitynode().getCategory()));
						
						if(!this.explantionTemp.containsValue(Rj.getCitynode().getCategory()))
						{
							this.explantionTemp.put(Rj.getCitynode().getCategory(),Rj.getCitynode().getTitle());
							this.diffMap.put(Rj.getCitynode().getTitle(),max);
							System.out.println("kommer inne her");
						}	//explantionTemp.put(Rj.getCitynode().getTitle(),1); 
						else 
						{
							this.diffMap.put(Rj.getCitynode().getTitle(),max);
							double diff = this.diffMap.get(this.explantionTemp.get(Rj.getCitynode().getCategory()));
							if(max>diff)
							{
								this.explantionTemp.put(Rj.getCitynode().getCategory(), Rj.getCitynode().getTitle());
							}
						}
						
					}
				}
		
				}
			
			
			return differnce; 
			
			
		}
		
		
		private double computeSim2(User a,User b)
		{
			
			Set <Rating> setU = a.getRatings().size()>b.getRatings().size()?a.getRatings():b.getRatings();
			Set <Rating> setV = setU.equals(a.getRatings())?b.getRatings():a.getRatings(); 
			
			double sdevU = computeStandardDeviation(setU);
			double sdevV = computeStandardDeviation(setV);
			
			
			

			
			double meanU = computeMean(setU);
			double meanV =  computeMean(setV);
			double sum = 0; 
			
			
			for(Rating Ri : setU)
			{
				for(Rating Rj : setV)
				{
					if(Rj.getCitynode().getId()==Ri.getCitynode().getId())
					{
						sum=+(Ri.getRating()-meanU)*(Rj.getRating()-meanV);
						//explantionTemp.put(Rj.getCitynode().getTitle(),1); ;
					}
				}
		
				}
			
	
			
			if(sdevU*sdevV!=0)
				return sum/(sdevU*sdevV); 
			else 
				return 0;
			
		}
		
		
		
		private double computeStandardDeviation(Set <Rating> ratings)
		{
		
			double mean = computeMean(ratings); 
			double dev = 0; 
			
			for(Rating rating:ratings)
			{
				dev+=Math.pow((rating.getRating()-mean),2.0); 
			}
			
			
			return Math.sqrt(dev/ratings.size());
		}
		
		
		

	
		
	//find citynodes 	

	public List <Recommendation> findRecommendationsFromUserRating(Context c,long userId,User u)
	{ 
		
		u.setCurrentRecommendations(new HashSet<Recommendation>()); 
		
		
	
		
		User userOfIntrest = udao.findByID(userId, false); 
		 
		Set <Rating> ratings = userOfIntrest.getRatings(); 
		
		List <Recommendation> recommendations = new ArrayList<Recommendation>();  
		
		for(Rating r : ratings)
		{
		
				Recommendation newRec = new Recommendation();
			
				//newRec.setSystemRating(90); 
				//newRec.setTextualExplanation("Average rating from " + (((int)Math.random()+1)*10)+ " users");
			
				newRec.setPersonalized(false); 
				newRec.setNode(r.getCitynode()); 
				recommendations.add(newRec);
		
		}
		for(Recommendation r : recommendations)
		{
			u.getCurrentRecommendations().add(r);
	
		}
		
		for(Recommendation r : recommendations)
		{
			
			r.setUser(u); 
			rdao.makePersistent(r);
		}
		
		for(Recommendation r : recommendations)
		{
			
			Citynode n = r.getNode();
			double distance = DistanceOp.distance(c.getUserLocation(),r.getNode().getLocation());
			
			r.setDistanceToUser((int)(distance*100.0*1000.0)); 
			
			if(n.getRaters()!=null)
			{
				double sumRating = 0.0;
				int number = 0;
				for(User userRating : n.getRaters())
				{
					if(userRating.getRating(n)!=null)
					{
						number++;
						sumRating+=userRating.getRating(n).getRating();
					}	
					
				}
				
				r.setSystemRating((int)((sumRating/number)*100));
				r.setTextualExplanation("Average rating from " + number + " users");
				r.setPersonalized(true);
			}
			
		}
		

		

		
		return recommendations; 
	}

		
		
	public User findUser(Context c,long userId,User u) {
	
		User userOfIntrest = udao.findByID(userId, false); 
		
		Set returnRatings = new HashSet<Rating>();
		
		for(Rating rating : userOfIntrest.getRatings())
		{
			rating.setUserId(userOfIntrest.getId());
			double distance = DistanceOp.distance(c.getUserLocation(),rating.getCitynode().getLocation())*(100.0*1000.0);
			if(distance<10000)
				returnRatings.add(rating); 
		}
		 
		userOfIntrest.setRatings(returnRatings);
		//return recommendations; 
		return userOfIntrest;
	}



	@Override
	public List<Recommendation> getRecommendationsForSpesificPoint(User u,
			Point p) {
		// TODO Auto-generated method stub
		return null;
	}



	@Override
	public UserModel getUserModel(User user) {
		// TODO Auto-generated method stub
		return null;
	}

	
	

	public boolean handleExplicitFeedback(Citynode cityNode,
			User user,double feedback) {
		
		User u = udao.findByID(user.getId(),false); 
		
	
		cityNode = cdao.findByID(cityNode.getId(), false); 
		
		for(Rating rating : u.getRatings())
		{
			if(cityNode.getId()==rating.getId())
			{
				rating.setRating(feedback); 
				this.ratingdao.makePersistent(rating); 
				return true; 
			}
		}
		
		Rating newRating = new Rating(); 
		
		newRating.setCitynode(
				cityNode);
		newRating.setRating(feedback); 
		newRating.setUserId(user.getId()); 
		
		ratingdao.makePersistent(newRating); 
		

		cityNode.getRaters().add(u); 
		
		cdao.makePersistent(
				cityNode); 
		
		u.getRatings().add(newRating); 
		
		udao.makePersistent(u); 
		
		//Rating r = new 
		
		return true;
	}

	@Override
	public UserModel updateUserModel(
			HashMap<Long, Double> attributeIdProbValueMap, User user) {
		// TODO Auto-generated method stub
		return null;
	}












	


}
